//////////////////////////////////////////////////////////////////////////
//	"tform.h"
//------------------------------------------------------------------------
//	$Id: tform.h 118 2004-01-14 21:27:24Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	TFORM_H_INCLUDED
#define	TFORM_H_INCLUDED

#if		defined(WIN32)
# include	<tchar.h>
# include	<windows.h>
#endif
#include	<stdarg.h>

#if	defined(LINUX)
# ifndef	BOOL
#  define	BOOL	int
# endif
# ifndef	TRUE
#  define	TRUE	1
# endif
# ifndef	FALSE
#  define	FALSE	0
# endif
# ifndef	TCHAR
#   define	TCHAR	char
# endif
#endif

class	TForm
{
public:
	enum tform_enum
	{
		BUFFER_SIZE = 4096,
#if	defined(WIN32)
		E_FIGURE = 3,
#else
		E_FIGURE = 2,
#endif
		PART_SPC_DEFAULT = 3,
	};
#if		defined(WIN32)
	typedef _int64				INT64;
	typedef unsigned _int64		UINT64;
#elif	defined(LINUX)
	typedef long long			INT64;
	typedef unsigned long long	UINT64;
#endif

protected:
	enum opt_enum
	{
		OPT_OFF     ,
		OPT_LONG    ,			// l
		OPT_I64     ,			// I64
		OPT_LONGLONG = OPT_I64,	// ll
		OPT_SHORT   ,			// h
	};
	struct Format
	{
		BOOL		left_margin;	// %-
		BOOL		zero_pad;		// %0
		BOOL		print_sign;		// %+
		BOOL		sign_space;		// '% '
		BOOL		num_symbol;		// '%#'

		int			width;
		int			precision;
		int			part_ch;		// ',', '|', '_'
		int			part_spc;		// default 3

		unsigned	opt;

		int			type;
	};

	static const TCHAR	ntoa_utbl[16];
	static const TCHAR	ntoa_ltbl[16];

protected:
	static int		format_numstr(TForm::Format & fmt, const TCHAR * text, int sign, unsigned size, TCHAR * buffer);
	static TCHAR *	seppart(int sep, int spc, const TCHAR * text, TCHAR * buffer);

public:
	TForm();
	virtual ~TForm();

	static int		Printf(const TCHAR * form, ...);
	static int		SPrintf(TCHAR * buffer, const TCHAR * form, ...);
	static int		format(unsigned size, TCHAR * buffer, const TCHAR * form, va_list arg);

	static TCHAR *	utoa(UINT64 n, unsigned r, TCHAR * buf);
	static TCHAR *	utoa(UINT64 n, TCHAR * buf);
	static TCHAR *	utoa(unsigned n, TCHAR * buf);
	static TCHAR *	ntoahex(UINT64 n, BOOL cap, TCHAR * buf);
	static TCHAR *	ntoahex(unsigned n, BOOL cap, TCHAR * buf);
	static TCHAR *	ntostr103(UINT64 size, int sn, TCHAR * buffer);
	static TCHAR *	ntostr210(UINT64 size, int sn, TCHAR * buffer);
};

#endif
